/*
	Copyright (c) 2004 Jonatan Kronqvist

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the "Software"),
	to deal in the Software without restriction, including without limitation
	the rights to use, copy, modify, merge, publish, distribute, sublicense,
	and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
	IN THE SOFTWARE.
*/


#ifndef __BUFFER_H__
#define __BUFFER_H__


#include "../SDK/foobar2000.h"
#include "../helpers/helpers.h"

#include "macros.h"


class buffer
{
public:
	buffer();
	buffer(int size);
	~buffer();

	bool append(int integer);
	bool append(unsigned short shortint);
	bool append(char byte);
	bool append(unsigned char byte);
	bool append(string8 str);

	int length();
	int size();
	void clear();
	char* get_ptr();

private:
	char *m_buf;
	unsigned int m_len, m_size;
};



#endif /*__BUFFER_H__*/